!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program Arare
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: arare.f90,v 1.10 2005/02/07 10:12:29 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!ϤϽవ̷.
!
!== Future Plans
!

                                                                 !=end

program arare
                                                                 !=begin
  !== Dependency
  use gt4_history
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use dc_message
  use debugset, only: debugset_init
  use gridset,  only: gridset_init, DimXMin, DimXMax, DimZMin, DimZMax, &
       &              RegZMin, RegZMax, XMin, XMax, ZMin, ZMax, &
       &              f_X, s_X, f_Z, s_Z
  use fileset,  only: fileset_init, cfgfile, basicfile, distrbfile
  use expname,  only: expname_init
  use linlib,   only: linlib_init
  use bcset,    only: bcset_init
  use arareprm, only: arareprm_init 
  use differentiate_center4

                                                                 !=end
  implicit none

  real(8), allocatable  :: ff_PotTemp_nl(:,:)
  real(8), allocatable  :: ss_Exner_nl(:,:)
  real(8), allocatable  :: fs_VelX_nl(:,:)
  real(8), allocatable  :: sf_VelZ_nl(:,:)

  real(8), allocatable  :: ss_DVelZDZAnl_nl(:,:)
  real(8), allocatable  :: ss_DVelZDZ_nl(:,:)
  real(8), allocatable  :: ss_ErrorDVelZDZ_nl(:,:)

  real(8), parameter :: pi=3.14159d0  
  integer  ::  i,k
  

  type(gt_history)      :: ss_reg, fs_reg, sf_reg, ff_reg
  type(gt_history)      :: ss_dim, fs_dim, sf_dim, ff_dim
  

!!!
!!!
!!!
  !--- I/O ե̾ν
  call fileset_init

  !--- ǥХν
  call debugset_init(cfgfile)

  !--- ʻν
  call gridset_init(cfgfile)
  
  !--- ¸̾ν
  call expname_init(cfgfile)
  
  !--- ׻ɤ߹
  call arareprm_init(cfgfile)

  !--- 
  call bcset_init(cfgfile)

  !--- ׻饤֥ν. 
  !--- ϥ顼 z η׻ΰ礭
  call linlib_init(cfgfile, RegZMax - RegZMin)
  
  !--- ϥե
  call ArareOpenRegFile
  call ArareOpenDimFile


!!!
!!!ѿν
!!!  
  !--- γ, 
  call ArareAlloc


!!!
!!!ʬƥ
!!!

  !--- δؿ

  do i = DimXMin, DimXMax  
     sf_VelZ_nl(i,:) = sin(2.0d0 * pi * f_Z(:) / (ZMax - ZMin) ) 
  end do

!  do k = DimZMin, DimZMax  
!     fs_VelX_nl(:,k) = sin(2.0d0 * pi * f_X(:) / (XMax - XMin) ) 
!  end do

  !--- Ūʬؿ

  do i = DimXMin, DimXMax
     ss_DVelZDZAnl_nl(i,:) =    &
          & 2.0d0 * pi / (ZMax - ZMin)  & 
          & * cos(2.0d0 * pi * s_Z(:) / (ZMax - ZMin) )
  end do

!  do k = DimZMin, DimZMax
!     ss_DVelZDZAnl_nl(:,k) =    &
!          & 2.0d0 * pi / (XMax - XMin)  & 
!          & * cos(2.0d0 * pi * s_X(:) / (XMax - XMin) )
!  end do


! ʬ׻

  ss_DVelZDZ_nl = ss_dz_sf(sf_VelZ_nl)

! 

  ss_ErrorDVelZDZ_nl = ss_DVelZDZ_nl - ss_DVelZDZAnl_nl

  !--- ե
  call ArareOutputRegFile
  call ArareOutputDimFile

  !--- ʬ黻ƥѥե

  call ArareOutputDiff
  
  !--- ϥեΥ
  call ArareCloseRegFile
  call ArareCloseDimFile
  
  
contains


!!!
!!!γ, 
!!!
  subroutine ArareAlloc
!    use distrbset, only: fs_VelXDistrb, sf_VelZDistrb, &
!         &               ss_ExnerDistrb, ff_PotTempDistrb

    call BeginSub("ArareAlloc", &
&                 fmt="%c",     &
&                 c1="Allocate and initialize allocatable variables.")

    allocate( fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ff_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_DVelZDZAnl_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_DVelZDZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_ErrorDVelZDZ_nl(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_nl = 0.0d0

    sf_VelZ_nl = 0.0d0

    ss_Exner_nl = 0.0d0
    
    ff_PotTemp_nl = 0.0d0

    !®پν
    fs_VelX_nl = 0.0d0
    sf_VelZ_nl = 0.0d0

    !̵Ϥν
    ss_Exner_nl = 0.0d0

    !̤ν
    ff_PotTemp_nl = 0.0d0

    call EndSub("ArareAlloc")

  end subroutine ArareAlloc


!!!
!!!ϥե. ׻ΰΤ
!!! 
  subroutine ArareOpenRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax, &
         & NX, NZ, f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_RegFile, sf_RegFile, ss_RegFile, ff_RegFile

    call BeginSub("ArareOpneRegFile", &
&                 fmt="%c",           &
&                 c1="Initialize output file name and variables in physical region.")
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/NX+1, NZ/),                       &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/), origin=0.0,              &
         & interval=0.0,                     &
         & history = fs_reg)
    
    ! ѿ
    call HistoryPut('x', f_X(RegXMin: RegXMax), fs_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), fs_reg)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_RegFile,                               &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/NX, NZ+1/),                       &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), sf_reg)
    call HistoryPut('z', f_Z(RegXMin: RegXMax), sf_reg)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_RegFile,                            &         
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                         &
         & dimsizes=(/NX, NZ/),                       &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_reg)
    
    ! ѿ
    call HistoryPut('x', s_X(RegXMin+1: RegXMax), ss_reg)
    call HistoryPut('z', s_Z(RegXMin+1: RegXMax), ss_reg)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ff_RegFile,                            &         
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                         &
         & dimsizes=(/NX+1, NZ+1/),                       &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ff_reg)
    
    ! ѿ
    call HistoryPut('x', f_X(RegXMin: RegXMax), ff_reg)
    call HistoryPut('z', f_Z(RegXMin: RegXMax), ff_reg)

    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_reg)    
    ! 
    call HistoryAddVariable(                            &
         & varname='PotTemp', dims=(/'x','z'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                 & 
         & history = ff_reg)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z'/),             &
         & longname='zonal velocity',         &
         & units='m/s', xtype='double',                & 
         & history = fs_reg)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z'/),             &
         & longname='vertical velocity',         &
         & units='m/s', xtype='double',                & 
         & history = sf_reg)    
    
    call EndSub("ArareOpneRegFile")
    
  end subroutine ArareOpenRegFile


!!!
!!!ե. Ĺ֥ƥåפǽ. ׻ΰΤ
!!!
  subroutine ArareOutputRegFile
    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax

    call BeginSub("ArareOutputRegFile", &
&                 fmt="%c",             &
&                 c1="Output variables in physical region.")

    call HistoryPut('Exner', &
         & ss_Exner_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('PotTemp', &
         & ff_PotTemp_nl(RegXMin:RegXMax, RegZMin:RegZMax), ff_reg)
    call HistoryPut('VelX', &
         & fs_VelX_nl(RegXMin:RegXMax, RegZMin+1:RegZMax), fs_reg)
    call HistoryPut('VelZ', &
         & sf_VelZ_nl(RegXMin+1:RegXMax, RegZMin:RegZMax), sf_reg)

    call EndSub("ArareOutputRegFile")

  end subroutine ArareOutputRegFile


!!!
!!!ϥեΥ. ׻ΰΤ
!!!  
  subroutine ArareCloseRegFile

    call BeginSub("ArareCloseRegFile", &
&                 fmt="%c", &
&                 c1="Close output file name for physical region.")

    call HistoryClose( ss_reg )
    call HistoryClose( fs_reg )
    call HistoryClose( sf_reg )
    call HistoryClose( ff_reg )

    call EndSub("ArareCloseRegFile")

  end subroutine ArareCloseRegFile


!!!
!!!ϥե. ΰ
!!!
  subroutine ArareOpenDimFile
    use gridset, only: f_X, f_Z, s_X, s_Z
    use expname, only: exptitle, expsrc, expinst
    use fileset, only: fs_DimFile, sf_DimFile, ss_DimFile, ff_DimFile

    integer::   N

    call BeginSub("ArareOpneDimFile", &
&                  fmt="%c",         &
&     c1="Initialize output file name and variables in all computational region.")

    N = size(f_X, 1)

    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = fs_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/N, N/),                           &
         & longnames=(/'X-coordinate',                     &
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/), origin=0.0,              &
         & interval=0.0, &
         & history = fs_dim)
    
    ! ѿ
    call HistoryPut('x', f_X, fs_dim)
    call HistoryPut('z', s_Z, fs_dim)
    
    ! ҥȥ꡼
    call HistoryCreate(                                    &
         & file = sf_DimFile,                              &
         & title = exptitle,                               &
         & source = expsrc,                                &
         & institution = expinst,                          &
         & dims=(/'x','z'/),                           &
         & dimsizes=(/N, N/),                           &
         & longnames=(/'X-coordinate',                     & 
         &             'Z-coordinate'/),                   &
         & units=(/'m','m'/),                          &
         & origin=0.0,                                     &
         & interval=0.0,                                   &
         & history = sf_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, sf_dim)
    call HistoryPut('z', f_Z, sf_dim)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ss_DimFile,                            &
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                         &
         & dimsizes=(/N, N/),                         &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ss_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, ss_dim)
    call HistoryPut('z', s_Z, ss_dim)
    
    ! ѿ
    call HistoryPut('x', s_X, sf_dim)
    call HistoryPut('z', f_Z, sf_dim)

    ! ҥȥ꡼
    call HistoryCreate(                                  &
         & file = ff_DimFile,                            &
         & title = exptitle,                             &
         & source = expsrc,                              &
         & institution = expinst,                        &
         & dims=(/'x','z'/),                         &
         & dimsizes=(/N, N/),                         &
         & longnames=(/'X-coordinate',                   &
         &             'Z-coordinate'/),                 &
         & units=(/'m','m'/), origin=0.0,            &
         & interval=0.0,                                 &
         & history = ff_dim)
    
    ! ѿ
    call HistoryPut('x', f_X, ff_dim)
    call HistoryPut('z', f_Z, ff_dim)
    
    ! ̵
    call HistoryAddVariable(                             &
         & varname='Exner', dims=(/'x','z'/),        &
         & longname='nondimensional pressure', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    ! 
    call HistoryAddVariable(                            &
         & varname='PotTemp', dims=(/'x','z'/),      &
         & longname='virtual potential temperature',    &
         & units='K', xtype='double',                   & 
         & history = ff_dim)    
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelX', dims=(/'x','z'/),        &
         & longname='zonal velocity',                   &
         & units='m/s', xtype='double',                 & 
         & history = fs_dim)        
    ! ®
    call HistoryAddVariable(                            &
         & varname='VelZ', dims=(/'x','z'/),        &
         & longname='vertical velocity',                &
         & units='m/s', xtype='double',                 & 
         & history = sf_dim)    

    call EndSub("ArareOpneDimFile")

  end subroutine ArareOpenDimFile


!!!
!!!ե. Ĺ֥ƥåפͤ. ΰ
!!!
  subroutine ArareOutputDimFile

    call BeginSub("ArareOutputDimFile", &
&                 fmt="%c",            &
&                 c1="Output variables in all computational region.")

    call HistoryPut('Exner', ss_Exner_nl, ss_dim)
    call HistoryPut('PotTemp', ff_PotTemp_nl, ff_dim)
    call HistoryPut('VelX',  fs_VelX_nl, fs_dim)
    call HistoryPut('VelZ',  sf_VelZ_nl, sf_dim)

    call EndSub("ArareOutputDimFile")

  end subroutine ArareOutputDimFile


!!!
!!!ϥեΥ. ΰ
!!!  
  subroutine ArareCloseDimFile

    call BeginSub("ArareCloseDimFile", &
&                 fmt="%c",            &
&                  c1="Close output file name for all computational region.")

    call HistoryClose( ss_dim )
    call HistoryClose( fs_dim )
    call HistoryClose( sf_dim )
    call HistoryClose( ff_dim )

    call EndSub("ArareCloseDimFile")

  end subroutine ArareCloseDimFile

!!!
!!!ʬ黻ƥѽϥ֥롼
!!!

  subroutine ArareOutputDiff

    use gridset, only: RegXMin, RegXMax, RegZMin, RegZMax

    !---׻ΰѥҥȥѿɲ

    call HistoryAddVariable(                             &
         & varname='DVelZDZ', dims=(/'x','z'/),        &
         & longname='numerically derived z-velosity', units='1/s',&
         & xtype='double',                               & 
         & history = ss_reg)    
    call HistoryAddVariable(                             &
         & varname='DVelZDZAnl', dims=(/'x','z'/),        &
         & longname='analytically derived z-velosity', units='1/s',&
         & xtype='double',                               & 
         & history = ss_reg)    
    call HistoryAddVariable(                             &
         & varname='ErrorDVelZDZ', dims=(/'x','z'/),        &
         & longname='error of numerical differenciation', units='1/s',&
         & xtype='double',                               & 
         & history = ss_reg)    

    !---ΰѥҥȥѿɲ

    call HistoryAddVariable(                             &
         & varname='DVelZDZ', dims=(/'x','z'/),        &
         & longname='numecally derived z-velosity', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    call HistoryAddVariable(                             &
         & varname='DVelZDZAnl', dims=(/'x','z'/),        &
         & longname='analytically derived z-velosity', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    
    call HistoryAddVariable(                             &
         & varname='ErrorDVelZDZ', dims=(/'x','z'/),        &
         & longname='error of numerical differenciation', units='1',&
         & xtype='double',                               & 
         & history = ss_dim)    

    !--- ׻ΰѥҥȥ

    call HistoryPut('DVelZDZ',   &
         & ss_DVelZDZ_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('DVelZDZAnl',    &
         & ss_DVelZDZAnl_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)
    call HistoryPut('ErrorDVelZDZ',    &
         & ss_ErrorDVelZDZ_nl(RegXMin+1:RegXMax, RegZMin+1:RegZMax), ss_reg)

    !--- ΰѥҥȥ

    call HistoryPut('DVelZDZ', ss_DVelZDZ_nl, ss_dim)
    call HistoryPut('DVelZDZAnl', ss_DVelZDZAnl_nl, ss_dim)
    call HistoryPut('ErrorDVelZDZ', ss_ErrorDVelZDZ_nl, ss_dim)

  end subroutine ArareOutputDiff 

end program arare
